#ifndef FE_OBJECT
#define FE_OBJECT

#include <fxengine/space.h>
#include <fxengine/triangle.h>

#include <stdint.h>
#include <stdbool.h>


struct fe_object
{
    fe_triangle * faces;
    uint32_t f_size;
    bool f_owner;
    fe_ivertex * points;
    uint32_t p_size;
    bool p_owner;
};
typedef struct fe_object fe_object;

void fe_object_init(fe_object * object);

void fe_object_set_points(fe_object * object, fe_ivertex * points, uint32_t n, bool copy);

void fe_object_set_faces(fe_object * object, fe_triangle * faces, uint32_t n, bool copy);

void fe_object_delete(fe_object * object);

void fe_object_display(fe_object * object);

void fe_object_debug(const fe_object * object);

fe_ipoint* fe_object_get_vertex(const fe_object * object, const int n);

#endif
