#ifndef FE_TEXTURE_H
#define FE_TEXTURE_H 
#include <stdbool.h>

/** Header pour les textures de FxEngine
 * format - textures monochromes au format 8x8 => stocké sur 8 unsigned char
 * accès  - une texture est définie par son numéro
 *		    l'accès à un pixel se fait avec FE_get_pixel
**/

/** numéros d'accès des textures : **/
#define FE_T_BLANC  0
#define FE_T_NOIR 	1
#define FE_T_CAISSE 2

/** tableau des textures : défini dans <texture.c> **/
extern unsigned char const FE_textures[][8];

/** FE_get_pixel - accès à un pixel individuel d'une texture
 * x et y sont compris entre 0 et 7
 * numéro de texture classique
 * retourne la couleur sur un bit
**/
bool FE_get_pixel(int texture_num, int x, int y);

#endif